unit rechner;

interface

(*
   Taschenrechner mit purer Tastaturbedienung
   by D.Schroeder 05/2010

   www.zabex.de

*)

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, math, ExtCtrls, jpeg,Clipbrd;

type
  TFormRechner = class(TForm)
    LabelInput: TLabel;
    LabelAlles: TLabel;
    ImageLegende: TImage;
    LabelHilfe: TLabel;
    PanelMemory: TPanel;
    ListBoxMemory: TListBox;
    Label2: TLabel;
    LabelE1: TLabel;
    LabelE2: TLabel;
    LabelVersion: TLabel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
    eingabezeile:string;
    val:array[1..99] of extended;
    op:array[1..99] of char;
    prioritaet:array[1..99] of integer;
    stackindex:integer;
    akku:extended;
    klammerebene:integer;
    memory:array[1..9] of string;
    legendeAngezeigt:boolean;
    neueZahl:boolean;
    error:boolean;
    procedure uebernehmeX(x:extended);
    procedure strg_v;
    procedure strg_c;
    function  myfloatToStr(x:extended):string;
  public
    { Public-Deklarationen }
    function  txtToNum(txt: string): extended;
    procedure berechneTeilausdruck;
    procedure hoeheAnpassen;
  end;

var
  FormRechner: TFormRechner;

implementation

{$R *.DFM}
//------------------------------------------------------------------------------
function TFormRechner.myfloatToStr(x:extended):string;
var
  p:integer;
  txt:string;
begin
  txt:=floatToStrF(x,ffGeneral, 16,0);
  p:=pos('E',txt);
  if p>0 then txt[p]:='e';
  result:=txt;
end;

//------------------------------------------------------------------------------
function getVal(txt:string; charpos:integer):extended;
begin
  result:=(  StrTofloat(copy(txt,1,charpos-1)) +
             StrTofloat('0'+decimalseparator+copy(txt,charpos+1,999))
          );
end;

//------------------------------------------------------------------------------
function TFormRechner.txtToNum(txt: string): extended;
var
  p:integer;
  wert:extended;
begin
  txt:=trim(txt);
  try
    wert:=StrTofloat(txt);
  except
    wert:=0;
  end;
  p:=pos('T',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E12;
  p:=pos('G',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E9;
  p:=pos('M',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E6;
  p:=pos('K',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E3;
  p:=pos('k',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E3;
  p:=pos('R',txt);
  if p>0 then  wert:=getVal(txt,p);
  p:=pos('r',txt);
  if p>0 then  wert:=getVal(txt,p);
  p:=pos('m',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E-3;
  p:=pos('u',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E-6;
  p:=pos('n',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E-9;
  p:=pos('p',txt);
  if p>0 then  wert:=getVal(txt,p)* 1E-12;
  result:=wert;
end;

//------------------------------------------------------------------------------
procedure TFormRechner.FormKeyPress(Sender: TObject; var Key: Char);
var
  i,len:integer;
begin
  len:=length(eingabezeile);
  if (key='?') or (key='') then begin
    legendeAngezeigt:=not legendeAngezeigt;
    hoeheAnpassen;
    exit;
  end;

  if (key=',') or (key='.') then key:=decimalseparator;
  if key= #13 then key:='=';

  if key = #8 then begin
    if (len>0) and not neueZahl
    then begin
      eingabezeile:=copy(eingabezeile,1,len-1);
      akku:=txtToNum(eingabezeile);
      labelAlles.Caption:=copy(labelAlles.Caption,1,length(labelAlles.Caption)-1);
    end;
  end else begin
    if ord(key) > 31 then begin
      labelAlles.Caption:=labelAlles.Caption+Key;
    end;

    try
      case key of
      '\': begin
            PanelMemory.visible:=false;
            ListBoxMemory.clear;
            for i:=1 to 9 do memory[i]:='';
            hoeheAnpassen;
            labelAlles.Caption:=copy(labelAlles.Caption,1,length(labelAlles.Caption)-1);
          end;
      #27: begin
             stackindex:=0;
             klammerebene:=0;
             eingabezeile:='0';
             akku:=0;
             labelAlles.Caption:='';
             error:=false;
             neueZahl:=true;
           end;
      '=': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=akku;
                op[stackindex]:='=';
                prioritaet[stackindex]:=-99999; //1=+-  2=*/
                berechneTeilausdruck;
                stackindex:=0;
                klammerebene:=0;
               end;
               neueZahl:=true;
             end;
      ' ': begin //Kehrwert
            if len>0 then begin
              labelAlles.Caption:=copy(labelAlles.Caption,1,length(labelAlles.Caption)-1)+' 1/x ';
              akku:=1/akku;
              eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      '_': begin //Vorzeichenwechsel
            if len>0 then begin
              akku:=0-akku;
              eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'b': begin //Grad in Bogenma
            if len>0 then begin
              akku:=akku/180.0*PI;
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'B': begin //Bogenma in Grad
            if len>0 then begin
              akku:=akku/PI*180.0;
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'l': begin //ln zur Basis e
            if len>0 then begin
              akku:=ln(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'L': begin //log zur Basis 10
            if len>0 then begin
              akku:=ln(akku)/ln(10);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'Z','z': begin //log zur Basis 2
            if len>0 then begin
              akku:=ln(akku)/ln(2);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'e': begin // Wiss. Notation, z.B. 1e-7
             eingabezeile:=eingabezeile+Key;
           end;
      'E': begin // e^x
            if len>0 then begin
              akku:=exp(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      's': begin //sinus
            if len>0 then begin
              akku:=sin(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'S': begin //arcsinus
             if len>0 then begin
              akku:=arcsin(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'c': begin //cosinus
             if len>0 then begin
              akku:=cos(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'C': begin //arcCosinus
             if len>0 then begin
              akku:=arccos(akku);
              eingabezeile:=myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      't': begin //tangens
             if len>0 then begin
               eingabezeile:=myfloatToStr(tan(txtToNum(eingabezeile)));
             end;
             neueZahl:=true;
           end;
      'T': begin //arcTan
            if len>0 then begin
              eingabezeile:=myfloatToStr(arcTan(txtToNum(eingabezeile)));
             end;
             neueZahl:=true;
           end;
      '#': begin //Pi
             akku:=PI;
             eingabezeile:= myfloatToStr(akku);
             neueZahl:=true;
           end;
      '<': begin // *1000
             if len>0 then begin
               akku:=1000*akku;
               eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      '>': begin // /1000
             if len>0 then begin
               akku:=akku/1000;
               eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;

      'q': begin //Quadrat  ^2
             if len>0 then begin
               akku:=sqr(akku);
               eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'w': begin //wurzel  ^(1/2)
             if len>0 then begin
               akku:=sqrt(abs(akku));
               eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;
      'y': begin //  x hoch y  (auch mit ^, wegen Deadkeys aber in KeyDown behandelt)
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=akku; //txtToNum(eingabezeile);
                op[stackindex]:='^';
                prioritaet[stackindex]:=3 +10*klammerebene; //1=+-  2=*/ 3=^
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
      'Y': begin //  x hoch 1/y
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=akku; //txtToNum(eingabezeile);
                op[stackindex]:='Y';
                prioritaet[stackindex]:=3 +10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;

      'W': begin // 3.wurzel  ^(1/3)
             if len>0 then begin
               akku:=power(abs(akku), 1/3);
               eingabezeile:= myfloatToStr(akku);
             end;
             neueZahl:=true;
           end;

      '(': begin
             inc(klammerebene);
             neueZahl:=true;
           end;
      ')': begin
             if (len>0) and (klammerebene>0) then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                prioritaet[stackindex]:=10*klammerebene;
                berechneTeilausdruck;
                dec(klammerebene);
                dec(stackindex);
              end;
              neueZahl:=true;
            end;

      '*': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                op[stackindex]:='*';
                prioritaet[stackindex]:=2 +10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
      '%': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                op[stackindex]:='%';
                prioritaet[stackindex]:=2+10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
      '/': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                op[stackindex]:='/';
                prioritaet[stackindex]:=2+10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
      '+': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                op[stackindex]:='+';
                prioritaet[stackindex]:=1+10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
      '-': begin
             if len>0 then begin
               if eingabezeile[length(eingabezeile)]<>'e' then begin
                  inc(stackindex);
                  val[stackindex]:=Akku;
                  op[stackindex]:='-';
                  prioritaet[stackindex]:=1+10*klammerebene; //1=+-  2=*/
                  berechneTeilausdruck;
                  neueZahl:=true;
                end else begin
                  eingabezeile:=eingabezeile+Key;
                end;
             end;
           end;
      '|': begin
             if len>0 then begin
                inc(stackindex);
                val[stackindex]:=Akku;
                op[stackindex]:='|';
                prioritaet[stackindex]:=2+10*klammerebene; //1=+-  2=*/
                berechneTeilausdruck;
             end;
             neueZahl:=true;
           end;
       '0'..'9':begin
           if neueZahl then begin
             neueZahl:=false;
             eingabezeile:='';
           end;
           eingabezeile:=eingabezeile+Key;
           akku:=txtToNum(eingabezeile);
           end;
       'r','R','M','K','k','m','u','n','p',',','.': begin
          eingabezeile:=eingabezeile+Key;
          neueZahl:=false;
          akku:=txtToNum(eingabezeile);
        end;
      end;     //case
    except
     labelInput.Caption:='ERROR';
     error:=true;
    end
  end;
  if not error then begin
    labelInput.caption:=eingabezeile;
  end;
end;


//------------------------------------------------------------------------------
procedure TFormRechner.berechneTeilausdruck;
var
  fertig:boolean;
begin
  try
    repeat
      fertig:=true;
      if stackindex>1 then begin
        if (prioritaet[stackindex-1] >= prioritaet[stackindex])
        then begin
          case op[stackindex-1] of
          '=': begin
                 op[stackindex-1]:=op[stackindex];
                 prioritaet[stackindex-1]:= prioritaet[stackindex];
                 dec(stackindex);
                 fertig:=false;
               end;
          '^': begin  //x^y
                 uebernehmeX(power(val[stackindex-1],  val[stackindex]));
                 fertig:=false;
               end;
          'Y': begin  // x^(1/y)
                 uebernehmeX(power(abs(val[stackindex-1]),  1/val[stackindex]));
                 fertig:=false;
               end;
          '*': begin
                 uebernehmeX(val[stackindex-1] * val[stackindex]);
                 fertig:=false;
               end;
          '%': begin
                 //x mod y = x  (x div y) * y.
                 uebernehmeX(val[stackindex-1] - val[stackindex] * trunc(val[stackindex-1] / val[stackindex]));
                 fertig:=false;
               end;
          '/': begin
                 uebernehmeX(val[stackindex-1] / val[stackindex]);
                 fertig:=false;
               end;
          '+': begin
                 uebernehmeX(val[stackindex-1] + val[stackindex]);
                 fertig:=false;
               end;
          '-': begin
                 uebernehmeX(val[stackindex-1] - val[stackindex]);
                 fertig:=false;
               end;
          '|': begin
                 uebernehmeX(1/( 1/val[stackindex-1] + 1/ val[stackindex]));
                 fertig:=false;
               end;
          end;
        end;
      end;
    until fertig;
    akku:=val[stackindex];
    eingabezeile:=myfloatToStr(akku);
  except
    labelInput.Caption:='ERROR';
    error:=true;
  end
end;

//------------------------------------------------------------------------------
procedure TFormRechner.uebernehmeX(x:extended);
begin
  val[stackindex-1]:=x;
  op[stackindex-1]:=op[stackindex];
  prioritaet[stackindex-1]:= prioritaet[stackindex];
  dec(stackindex);
end;

//------------------------------------------------------------------------------
procedure TFormRechner.FormCreate(Sender: TObject);
begin
  stackindex:=0;
  klammerebene:=0;
  error:=false;
  labelInput.Caption:='0';
  eingabezeile:='0';
  labelAlles.Caption:='';
  LabelHilfe.font.color:=$a0a0a0;
  ImageLegende.visible:=false;
  ListBoxMemory.clear;
  legendeAngezeigt:=false;
  hoeheAnpassen;
  neueZahl:=true;
end;

//------------------------------------------------------------------------------
procedure TFormRechner.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i,n:integer;
  gefunden:boolean;
  txt:string;
begin
  if (key = VK_F4) and (ssAlt in shift) then begin
    close;
  end;

  if key=$DC then begin //  ^ Taste
    inc(stackindex);
    val[stackindex]:=txtToNum(eingabezeile);
    op[stackindex]:='^';
    prioritaet[stackindex]:=3 +10*klammerebene; //1=+-  2=*/ 3=^
    berechneTeilausdruck;
    neueZahl:=true;
    labelAlles.Caption:=labelAlles.Caption+'^';
    key:=0;
  end;

  if (key >= VK_F1)and (key <= VK_F9) then begin
    n:=key - VK_F1+1;
    if not ((ssShift in shift) or(ssCtrl in shift))  then begin
      if length(memory[n])>0
      then begin
        labelInput.caption:=memory[n];
        eingabezeile:=memory[n];
        neueZahl:=false;
        labelAlles.Caption:=labelAlles.Caption+eingabezeile; //'F'+intToStr(n);
        akku:=txtToNum(eingabezeile);
      end;
    end else begin
      memory[n]:=labelInput.caption;
      PanelMemory.visible:=true;
      hoeheAnpassen;
      gefunden:=false;
      neueZahl:=true;
      labelAlles.Caption:=labelAlles.Caption+' =>F'+intToStr(n)+' ';
      for i:=0 to listBoxMemory.Items.count-1 do begin
        txt:=listBoxMemory.Items[i];
        if txt[2]=chr(48+n)
        then begin
          listBoxMemory.Items[i]:=('F'+intToStr(n)+': '+ labelInput.caption);
          gefunden:=true;
        end;
      end;
      if not gefunden
      then listBoxMemory.Items.Add('F'+intToStr(n)+': '+ labelInput.caption);
    end;
    key:=0;
  end; //Funktionstasten

  //Strg-C: Kopieren in Zwischenablage
  if (key = $43 {VK_C}) and (ssCtrl in shift) then begin
//    CopyTextToClipboard(handle, PChar(LabelInput.caption));
    strg_c;
    key:=0;
  end;
  if (key = $56 {VK_V}) and (ssCtrl in shift) then begin
    strg_v;
    key:=0;
  end;

  (*    Virtuelle Tastencodes:
VK_NULL      $00 NULL
VK_LBUTTON     $01 Linke Maustaste
VK_RBUTTON     $02 Rechte Maustaste
VK_CANCEL    $03 Fr die Verarbeitung von Control-Break
VK_MBUTTON    $04 Mittlere Maustaste (Dreitastenmaus)
--             $05 Nicht definiert
--              $06 Nicht definiert
--              $07 Nicht definiert
VK_BACK         $08 BACKSPACE Taste
VK_TAB          $09 TAB Taste
--              $0A Nicht definiert
--              $0B Nicht definiert
VK_CLEAR        $0C Lschtaste
VK_RETURN       $0D RETURN Taste
--              $0E Nicht definiert
--              $0F Nicht definiert
VK_SHIFT        $10 SHIFT Taste
VK_CONTROL      $11 STRG Taste
VK_MENU         $12 ALT Taste
VK_PAUSE        $13 PAUSE Taste
VK_CAPITAL      $14 CAPS LOCK Taste
--              $15 Reserviert fr Kanji-Systeme
--              $16 Reserviert fr Kanji-Systeme
--              $17 Reserviert fr Kanji-Systeme
--              $18 Reserviert fr Kanji-Systeme
--              $19 Reserviert fr Kanji-Systeme
--              $1A Nicht definiert
VK_ESCAPE       $1B ESC Taste
--              $1C Reserviert fr Kanji-Systeme
--              $1D Reserviert fr Kanji-Systeme
--              $1E Reserviert fr Kanji-Systeme
--              $1F Reserviert fr Kanji-Systeme
VK_SPACE        $20 LEERTASTE
VK_PRIOR        $21 PAGE UP Taste
VK_NEXT         $22 PAGE DOWN Taste
VK_END          $23 ENDE Taste
VK_HOME         $24 POS1 Taste
VK_LEFT         $25 Cursortaste links
VK_UP           $26 Cursortaste oben
VK_RIGHT        $27 Cursortaste rechts
VK_DOWN         $28 Cursortaste unten
VK_SELECT       $29 SELECT Taste
VK_PRINT        $2A Druck
VK_EXECUTE      $2B Taste Ausfhren (EXECUTE)
VK_SNAPSHOT     $2C PRINT SCREEN Taste fr Windows 3.0 und hher
VK_INSERT       $2D EINFG Taste
VK_DELETE       $2E ENTF Taste
VK_HELP         $2F Hilfetaste
VK_0            $30 Taste 0
VK_1            $31 Taste 1
VK_2            $32 Taste 2
VK_3            $33 Taste 3
VK_4            $34 Taste 4
VK_5            $35 Taste 5
VK_6            $36 Taste 6
VK_7            $37 Taste 7
VK_8            $38 Taste 8
VK_9            $39 Taste 9
--              $3A Nicht definiert
--              $3B Nicht definiert
--              $3C Nicht definiert
--              $3D Nicht definiert
--              $3E Nicht definiert
--              $3F Nicht definiert
--              $40 Nicht definiert
VK_A            $41 Taste A
VK_B            $42 Taste B
VK_C            $43 Taste C
VK_D            $44 Taste D
VK_E            $45 Taste E
VK_F            $46 Taste F
VK_G            $47 Taste G
VK_H            $48 Taste H
VK_I            $49 Taste I
VK_J            $4A Taste J
VK_K            $4B Taste K
VK_L            $4C Taste L
VK_M            $4D Taste M
VK_N            $4E Taste N
VK_O            $4F Taste O
VK_P            $50 Taste P
VK_Q            $51 Taste Q
VK_R            $52 Taste R
VK_S            $53 Taste S
VK_T            $54 Taste T
VK_U            $55 Taste U
VK_V            $56 Taste V
VK_W            $57 Taste W
VK_X            $58 Taste X
VK_Y            $59 Taste Y
VK_Z            $5A Taste Z
VK_LWIN         $5B Linke Windowstaste
VK_RWIN         $5C Rechte Windowstaste
VK_APPS         $5D Application-Taste
--              $5E Nicht definiert
--              $5F Nicht definiert
VK_NUMPAD0      $60 Numerisches Tastenfeld, Taste 0
VK_NUMPAD1      $61 Numerisches Tastenfeld, Taste 1
VK_NUMPAD2      $62 Numerisches Tastenfeld, Taste 2
VK_NUMPAD3      $63 Numerisches Tastenfeld, Taste 3
VK_NUMPAD4      $64 Numerisches Tastenfeld, Taste 4
VK_NUMPAD5      $65 Numerisches Tastenfeld, Taste 5
VK_NUMPAD6      $66 Numerisches Tastenfeld, Taste 6
VK_NUMPAD7      $67 Numerisches Tastenfeld, Taste 7
VK_NUMPAD8      $68 Numerisches Tastenfeld, Taste 8
VK_NUMPAD9      $69 Numerisches Tastenfeld, Taste 9
VK_MULTIPLY     $6A Multiplikationstaste
VK_ADD          $6B Additionstaste
VK_SEPARATOR    $6C Trenntaste
VK_SUBTRACT     $6D Subtraktionstaste
VK_DECIMAL      $6E Dezimaltrenntaste
VK_DIVIDE       $6F Divisionstaste
VK_F1           $70 F1 Taste
VK_F2           $71 F2 Taste
VK_F3           $72 F3 Taste
VK_F4           $73 F4 Taste
VK_F5           $74 F5 Taste
VK_F6           $75 F6 Taste
VK_F7           $76 F7 Taste
VK_F8           $77 F8 Taste
VK_F9           $78 F9 Taste
VK_F10          $79 F10 Taste
VK_F11          $7A F11 Taste
VK_F12          $7B F12 Taste
VK_F13          $7C F13 Taste
VK_F14          $7D F14 Taste
VK_F15          $7E F15 Taste
VK_F16          $7F F16 Taste
VK_F17          $80 F17 Taste
VK_F18          $81 F18 Taste
VK_F19          $82 F19 Taste
VK_F20          $83 F20 Taste
VK_F21          $84 F21 Taste
VK_F22          $85 F22 Taste
VK_F23          $86 F23 Taste
VK_F24          $87 F24 Taste
--              $88 Nicht belegt
--              $89 Nicht belegt
--              $8A Nicht belegt
--              $8B Nicht belegt
--              $8C Nicht belegt
--              $8D Nicht belegt
--              $8E Nicht belegt
--              $8F Nicht belegt
VK_NUMLOCK      $90 NUM LOCK Taste
VK_SCROLL       $91 SCROLL LOCK Taste
VK_LSHIFT       $A0 Linke Shift-Taste
VK_RSHIFT       $A1 Rechte Shift-Taste
VK_LCONTROL     $A2 Linke Strg-Taste
VK_RCONTORL     $A3 Rechte Strg-Taste
VK_LMENU        $A4 Linke Men-Taste
VK_RMENU        $A5 Rechte Men-Taste
VK_SEMICOLON      $BA Taste ;
VK_EQUAL          $BB Taste =
VK_COMMA          $BC Taste ,
VK_MINUS          $BD Taste -
VK_PERIOD         $BE Taste .
VK_SLASH          $BF Taste \
VK_BACKQUOTE      $C0 Taste `
VK_LEFTBRACKET    $DB Taste <
VK_BACKSHLASH     $DC Taste \    (auch ^)
VK_RIGHTBRACKET   $DD Taste >
VK_QUOTE          $DE Taste 
VK_??             $E2 Taste <
VK_PROCESSKEY     $E5 Process-Taste
VK_ATTN           $F6 Attn-Taste
VK_CRSEL          $F7 Clear-Selected-Taste
VK_EXSEL          $F8 EXSEL-Taste
VK_EREOF          $F9 EREOF-Taste
VK_PLAY           $FA Play-Taste
VK_ZOOM           $FB Zoom-Taste
VK_NONAME         $FC Noname-Taste
VK_PA1            $FD PA1-Taste
VK_OEM_CLEAR      $FE OEM-Clear
  *)
end;

//------------------------------------------------------------------------------
procedure TFormRechner.hoeheAnpassen;
begin
  if legendeAngezeigt
  then begin
    if PanelMemory.visible then begin
      imageLegende.top:= PanelMemory.Top + PanelMemory.height + 20;
    end else begin
      imageLegende.top:= PanelMemory.Top +20;
    end;
    FormRechner.height:=imageLegende.top+imageLegende.height+50;
    LabelHilfe.font.color:=clBlack;
    LabelHilfe.Caption:='? blendet Hilfe aus';
    ImageLegende.visible:=true;
    LabelE1.visible:=true;
    LabelE2.visible:=true;
    LabelVersion.visible:=true;
  end else begin
    if PanelMemory.visible then begin
      FormRechner.height:= PanelMemory.Top + PanelMemory.height + 50;
    end else begin
      FormRechner.height:= PanelMemory.Top+30 ;
    end;
    LabelHilfe.Caption:='? fr Hilfe';
    LabelHilfe.font.color:=$a0a0a0;
    ImageLegende.visible:=false;
    LabelE1.visible:=false;
    LabelE2.visible:=false;
    LabelVersion.visible:=false;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormRechner.strg_v;
var
  i:integer;
begin
  if Clipboard.HasFormat(CF_TEXT) then begin
    eingabezeile:=clipboard.AsText;
    for i:=1 to length(eingabezeile) do begin
      if (eingabezeile[i]='.')
      or (eingabezeile[i]=',')
      then eingabezeile[i]:=decimalSeparator;
    end;
    labelInput.Caption:=eingabezeile;
    labelAlles.Caption:=labelAlles.Caption+eingabezeile;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormRechner.strg_c;
begin
  clipboard.AsText:=eingabezeile;
end;

//------------------------------------------------------------------------------
end.
